/* ************************************** */
/*   ROBO-1 pic16f648a robo program-1     */
/* ************************************** */
#include <16f648a.H>   // include file set
#fuses INTRC_IO,NOWDT,PUT,NOPROTECT,NOLVP,NOMCLR  // config
#use Delay(Clock=4000000)  // cpu speed 4MHz set
#byte port_a=5	       // port_a address set 5 bank0
#byte port_b=6	       // port_b address set 6 bank0
// ԍ   0    1    2    3    4    5    6    7
//@@@@@stop    E Oi E ڰ
int led[8]={0x00,0x04,0x02,0x06,0x01,0x05,0x03,0x07};
int run[8]={0x00,0x10,0xA0,0x90,0x40,0x50,0x60,0xf0};
io_set(){              // io set program
  set_tris_a(0xff);    // port_a = all input
  set_tris_b(0x00);    // port_b = all output
}
main() {
  int a,n;                  //
  io_set();                 // i/o port set
  while(1) {                // endless LOOP
    a=~port_a & 0x3c;       // port_a & 00111100 => a
    switch(a){              //
       case 0x20:n=3;break;    // SW3  => n=3@
       case 0x10:n=2;break;    // SW2  => n=2@
       case 0x08:n=5;break;    // SW1  => n=5@Oi
       case 0x04:n=6;break;    // SW0  => n=6@E
       default:n=0;break;      // other=> n=0@~
    }
    port_b=run[n]+led[n];      // port_b => run LED data set
    delay_ms(100);             // wait 100msec
  }
}
