/* ************************************** */
/*   ROBO-2 pic16f648a robo program-2     */
/* ************************************** */
#include <16f648a.H>         // include file set
#fuses INTRC_IO,NOWDT,PUT,NOPROTECT,NOLVP,NOMCLR  // config
#use Delay(Clock=4000000)    // cpu speed 4MHz set
#byte port_a=5	       // port_a address set 5 bank0
#byte port_b=6	       // port_b address set 6 bank0
// ԍ   0    1    2    3    4    5    6    7
//@@@@@stop    E Oi E `
int led[8]={0x00,0x04,0x02,0x06,0x01,0x05,0x03,0x07};
int run[8]={0x00,0x10,0xA0,0x90,0x40,0x50,0x60,0xf0};
io_set(){              // io set program
  set_tris_a(0xff);    // port_a = all input
  set_tris_b(0x00);    // port_b = all output
}
main() {
  int a;                  //
  io_set();                 // i/o port set
  while(1) {                // endless LOOP
    a=~port_a & 0x03;       // port_a & 00000011 => a
    if(a==0x01){              //
       port_b=run[2]+led[2];delay_ms(2000);// ށ@@Qb
       port_b=run[3]+led[3];delay_ms(500); // @0.5b
    }
    else if(a==0x02){              //
       port_b=run[2]+led[2];delay_ms(2000);// ށ@@Qb
       port_b=run[6]+led[6];delay_ms(500); // E@0.5b
    }
    else{port_b=run[5]+led[5];}      // i
    delay_ms(100);                   // wait 100msec
  }
}
